;-------------------------------------------------
;  1st attempt at using a Child window
; -------------------------------------------------
.686
.model flat,stdcall
option casemap:none
include \masm32\include\windows.inc
include \masm32\include\user32.inc
include \masm32\include\kernel32.inc
include \masm32\include\gdi32.inc
includelib \masm32\lib\user32.lib
includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\gdi32.lib

WinMain  PROTO :DWORD,:DWORD,:DWORD,:DWORD
dwtoa    PROTO  :DWORD, lpBuffer: PTR BYTE
EnumChildProc PROTO hWnd:HWND, lParam: LPARAM 

.data               
colorbk                     dd       00ff0000h
cxClient                    dd       0 
cyClient                    dd       0 
holdbottom1            dd       0
i                                 dd       0
savemiddleofX        dd       0      ; middle of screen vertically
holdtoppane2          dd       0      ; top off Pane 2
holdheightpane2     dd       0      ; height of Pane 2
holdwidthpane2      dd       0      ; width of Pane 2      

AppName               db   'Screen',0
szDisplayName1    db   'PANE 1',0
szDisplayName2    db   'PANE 2',0

codecode         STRUCT 
cc1              db     ? 
cc2              db     ? 
cc3              db     ?
cc4              db     ? 
codecode         ENDS 

.data?
CommandLine LPSTR     ?
hInstance   HINSTANCE ?
RR          RECT      {?} 

.code
start:
	invoke GetModuleHandle, NULL
	mov    hInstance,eax
	invoke GetCommandLine
	invoke WinMain, hInstance, NULL, CommandLine, SW_SHOWDEFAULT
	invoke ExitProcess, eax

           WinMain PROC hInst:HINSTANCE, hPrevInst:HINSTANCE, CmdLine:LPSTR, CmdShow:DWORD
	LOCAL msg: MSG, hWnd: HWND,  hBrush: DWORD, ps: PAINTSTRUCT, ovl: WNDCLASSEX
           
	mov   ovl.cbSize, SIZEOF WNDCLASSEX
	mov   ovl.style, CS_VREDRAW or CS_HREDRAW 
	mov   ovl.style, CS_BYTEALIGNWINDOW
 	mov   ovl.lpfnWndProc, OFFSET ScrnProc
	mov   ovl.cbClsExtra, NULL
            mov   ovl.cbWndExtra, NULL
	push  hInst
	pop   ovl.hInstance
	invoke LoadIcon, NULL, IDI_APPLICATION
	mov   ovl.hIcon, eax
            invoke LoadCursor, NULL, IDC_ARROW
	mov   ovl.hCursor, eax
	invoke CreateSolidBrush, colorbk
           mov   hBrush, eax
	mov   ovl.hbrBackground, eax 
	mov   ovl.lpszMenuName, NULL
	mov   ovl.lpszClassName, OFFSET szDisplayName1
	mov   ovl.hIconSm, 0

            invoke RegisterClassEx, ADDR ovl
           invoke SystemParametersInfo, SPI_GETWORKAREA, 0, addr RR, 0        
      
         push edx                             ;  this code sets up middle of the screen vertically 
        push ebx
        mov eax, RR.bottom         ; find middle of entire screen
       xor edx, edx     
       mov ebx, 2                
       div ebx
       mov savemiddleofX, eax               ; middle of whole screen
       mov holdbottom1, eax                   ; height of Pane 1
       mov holdtoppane2, eax                 ; top of Pane 2
       mov holdheightpane2, eax            ; height of Pane 2
       mov eax, RR.right        
       mov holdwidthpane2, eax             ; width  of Pane 2       
       pop ebx
       pop edx      
      
; puts Pane 1 to screen
      invoke CreateWindowEx, WS_EX_ACCEPTFILES,  ADDR szDisplayName1,\
      ADDR AppName, WS_VSCROLL OR WS_OVERLAPPEDWINDOW,\
       RR.left, RR.top, RR.right, holdbottom1,  NULL, NULL, hInst, NULL                     
      mov hWnd, eax                     

      invoke ShowWindow, hWnd, SW_SHOWDEFAULT
      invoke UpdateWindow, hWnd             
      
      StartLoop:
          INVOKE GetMessage, ADDR msg, NULL, 0, 0
          cmp eax, 0
          je ExitLoop 
          INVOKE TranslateMessage, ADDR msg
          INVOKE DispatchMessage, ADDR msg
          jmp StartLoop
       ExitLoop: 
          mov eax, msg.wParam
          ret           
WinMain ENDP
  
        ScrnProc PROC uses ebx esi, hWnd:HWND, iMsg:UINT, wParam:WPARAM, lParam:LPARAM
        LOCAL ps: PAINTSTRUCT, hdc: HDC, String: BYTE, hBrush: dword 
        LOCAL lpBuffer: BYTE, hInst: HINSTANCE,  jps: WNDCLASSEX, frstchild: HWND 
        
        .if iMsg == WM_LBUTTONDOWN
          mov eax, lParam      ; loword
          and eax, 0FFFFh        
         mov cxClient,eax

          mov eax,lParam      ; hiword
          shr eax, 16    
          mov cyClient,eax
          
     ; END the Program
          .IF (cxClient > 15 && cxClient < 110) && (cyClient > 5 && cyClient < 45)
            invoke ExitProcess,NULL
            jmp goon20          
          .ENDIF
          
      .elseif iMsg==    WM_CREATE
	mov   jps.cbSize, SIZEOF WNDCLASSEX
	mov   jps.style, CS_VREDRAW or CS_HREDRAW 
 	mov   jps.lpfnWndProc, OFFSET ScrnProc
	mov   jps.cbClsExtra, NULL
            mov   jps.cbWndExtra, NULL
	push  hInst
	pop   jps.hInstance
	invoke LoadIcon, NULL, IDI_APPLICATION
	mov   jps.hIcon, eax
            invoke LoadCursor, NULL, IDC_ARROW
	mov   jps.hCursor, eax
	invoke CreateSolidBrush, colorbk
            mov   hBrush, eax
	mov   jps.hbrBackground, eax 
	mov   jps.lpszMenuName, NULL
	mov   jps.lpszClassName, OFFSET szDisplayName2
	mov   jps.hIconSm, 0
      
           invoke RegisterClassEx, ADDR jps
           invoke SystemParametersInfo, SPI_GETWORKAREA, 0, addr RR, 0
; puts Pane2 to screen
     invoke CreateWindowEx, WS_EX_ACCEPTFILES,  ADDR szDisplayName2,\
     NULL, WS_VSCROLL OR WS_OVERLAPPEDWINDOW OR WS_CHILD,\
     NULL, NULL, NULL, NULL, hWnd, frstchild, hInst, NULL                     
;      mov  hWnd, eax
      mov  frstchild, eax   ; ????
      
       .ELSEIF iMsg==WM_CHAR                            
      .ELSEIF iMsg==WM_SIZE
          invoke EnumChildWindows, hWnd, addr EnumChildProc,  addr RR
          ret 0
      .ELSEIF iMsg==WM_COMMAND
      .ELSEIF iMsg==WM_VSCROLL
      .ELSEIF iMsg==WM_PAINT
           invoke BeginPaint, hWnd, ADDR ps
           mov    hdc, eax                                                                
           invoke EndPaint, hWnd, ADDR ps
           ret 0 
goon20:           
  	.ELSEIF iMsg==WM_DESTROY
              invoke PostQuitMessage,NULL                                                                                                
	.ELSE
              invoke DefWindowProc, hWnd, iMsg, wParam, lParam
              ret    	 	  
	.ENDIF
            ret  
ScrnProc ENDP

EnumChildProc proc frstchild: HWND, lParam: LPARAM
        invoke MoveWindow, frstchild, 0, holdtoppane2, holdwidthpane2, holdheightpane2, TRUE     
        invoke ShowWindow, frstchild, SW_SHOW
        ret
EnumChildProc endp

dwtoa proc public uses esi edi dwValue:DWORD, lpBuffer:PTR BYTE	
    ; -------------------------------------------------------------
    ; convert DWORD to ascii string
    ; dwValue is value to be converted
    ; lpBuffer is the address of the receiving buffer
    ; EXAMPLE:
    ; invoke dwtoa,edx,ADDR buffer
    ;
    ; Uses: eax, ecx, edx.
    ; -------------------------------------------------------------

    mov	eax, dwValue
    mov edi, [lpBuffer]

    ; Is the value negative?

    .if	(sdword ptr eax < 0)
      mov byte ptr [edi], '-'	; store a minus sign
      inc edi
      neg eax			; and invert the value
    .endif

    mov esi, edi		; save pointer to first digit

    mov ecx, 10
    .while (eax > 0)		; while there is more to convert...
      xor edx, edx
      div ecx			; put next digit in edx
      add dl, '0'		; convert to ASCII
      mov [edi], dl		; store it
      inc edi
    .endw

    mov byte ptr [edi], 0	; terminate the string

    ; We now have all the digits, but in reverse order.
     .while (esi < edi)
      dec edi
      mov al, [esi]
      mov ah, [edi]
      mov [edi], al
      mov [esi], ah
      inc esi
    .endw
    
    ret
dwtoa endp
end start
